        PROGRAM pl_example3
        PARAMETER (n1=9,n2=9)
	INTEGER A(-1:N1,-1:N2)
	INTEGER B(-1:N1,-1:N2)
	INTEGER C(-1:N1,-1:N2)
	INTEGER D(-1:N1,-1:N2)
	INTEGER E(-1:N1,-1:N2)
        INTEGER io1,y1,io2,i_m1
c initialize
	do i1=-1,N1
	do i2=-1,N2
	A(i1,i2)=2*i1+i2
	B(i1,i2)=A(i1,i2)
	C(i1,i2)=A(i1,i2)
	D(i1,i2)=A(i1,i2)
	E(i1,i2)=A(i1,i2)
	enddo
	enddo
c original
	do i1=1,N1
	  do i2=1,N2
 	    A(i1,i2)=A(i1,i2)+A(i1-2,i2-2)*2
	  enddo
	enddo
c target
         DO io2 = 1,N2
          DO io1 = 1,2
            DO i1 = io1,N1,2
              y1=(i1-io1)/2
              i_m1=1+mod(mod((io2+2*y1)-1,N2)+N2,N2)
              DO i2 = i_m1,N2,N2
                 B(i1,i2)=B(i1,i2)+B(i1-2,i2-2)*2
              ENDDO
            ENDDO
          ENDDO
        ENDDO
c unimodular
	do j1=1-N1,N2-1
	  do j2=max(1,1-j1),min(N1,N2-j1)
	    i1=j2
	    i2=j1+j2
	    C(i1,i2)=C(i1,i2)+C(i1-2,i2-2)*2
	  enddo
	enddo
c unimodular + partitioning j2
	do j1=1-N1,N2-1
	  do j21 = 1,2
	    do j22 = j21,min(N1,N2-j1)-max(1,1-j1)+1,2
	      j2=j22+max(1,1-j1)-1
	      i1=j2
	      i2=j1+j2
	      D(i1,i2)=D(i1,i2)+D(i1-2,i2-2)*2
	    enddo
	  enddo
	enddo
c unimodular + partitioning j2 + normalization
	do j1=1-N1,N2-1
	  do j21 = 1,2
 	    do j22n = j21,j21+(min(N1,N2-j1)-max(1,1-j1)+1-j21)/2
		if (j21.le.(min(N1,N2-j1)-max(1,1-j1)+1)) then
	      		j22 = j21+ (j22n-j21)*2
	      		j2=j22+max(1,1-j1)-1
	      		i1=j2
	      		i2=j1+j2
	      		E(i1,i2)=E(i1,i2)+E(i1-2,i2-2)*2
		endif
	    enddo
	  enddo
	enddo
c comparison
	DO i1=1,N1
	DO i2=1,N2
c test partitioning
	if (A(i1,i2).ne.B(i1,i2)) then
 	write(*,*)"B:",A(i1,i2),B(i1,i2),i1,i2
	endif
c test unimodular
	if (A(i1,i2).ne.C(i1,i2)) then
  	write(*,*)"C:",A(i1,i2),C(i1,i2),i1,i2
	endif
c test unimodular + partitioning
	if (A(i1,i2).ne.D(i1,i2)) then
 	write(*,*)"D:",A(i1,i2),D(i1,i2),i1,i2
	endif
c test unimodular + partitioning + normalization
	if (A(i1,i2).ne.E(i1,i2)) then
 	write(*,*)"E:",A(i1,i2),E(i1,i2),i1,i2
	endif
	ENDDO
	ENDDO
        STOP
        END
