        PARAMETER (nmax=1023)
        DIMENSION a(1023+1,1023),x(1023)
        DIMENSION b(1023+1,1023),c(1023)
        REAL a,b,c,x
        DOUBLE PRECISION it0,it1,it2,it3
        REAL mflops,fp_ops,delta
        CHARACTER*20 argv
        CALL gettime(it0)
        narg=iargc()
        IF (narg.gt.1) THEN
          CALL getarg(1,argv)
          READ(argv,*) n
        ELSE 
          n=100
        ENDIF
        DO i = 1,n
          a(i,n+1)=1.0
          DO j = 1,n
            IF (i.eq.j) THEN
              a(i,j)=i
            ELSE 
              a(i,j)=3.0*sin(dble(i+j))
            ENDIF
          ENDDO
        ENDDO
        DO i = 1,n
          DO j = 1,n+1
            b(i,j)=a(i,j)
          ENDDO
        ENDDO
        CALL gettime(it1)
        DO i = 1,n
C$par doall
          DO j = 1,n
            IF (j.ne.i) THEN
              f=a(j,i)/a(i,i)
              DO k = i+1,n+1
                a(j,k)=a(j,k)-f*a(i,k)
              ENDDO
            ENDIF
          ENDDO
        ENDDO
