        PARAMETER (maxdim=5)
C	subroutine f3dFlow
        INTEGER miny(5),maxy(5),minz(5,5),maxz(5,5),is_idx1
        REAL rr1,wp,kd
        INTEGER mm(0:5,0:5,0:5)
        REAL t(0:5,0:5,0:5),u(0:5,0:5,0:5)
        REAL v(0:5,0:5,0:5),w(0:5,0:5,0:5)
        REAL ds(0:5,0:5,0:5),vc(0:5,0:5,0:5)
        REAL ds1(0:5,0:5,0:5),us(0:5,0:5,0:5)
        REAL ps(0:5,0:5,0:5),aj(0:5,0:5,0:5)
        REAL vs(0:5,0:5,0:5),ws(0:5,0:5,0:5)
        REAL cj(0:5,0:5,0:5),pp(0:5,0:5,0:5)
        REAL bj(0:5,0:5,0:5),bb(0:5,0:5,0:5)
        REAL dx(0:5),dy(0:5),dz(0:5)
        REAL xd(0:5),yd(0:5),zd(0:5)
        REAL xx(0:5),yy(0:5),zz(0:5)
        REAL xi(0:5),yj(0:5),zk(0:5)
        REAL dxh(0:5),dyh(0:5),dzh(0:5)
        DATA nx/1/,nmx/5/,ny/1/,nmy/5/,nz/1/,nmz/5/
C        call srandom(10001)
        dlat=1.
        z1=0.5
        density=100.
        DO i = 0,5
          DO j = 0,5
            DO k = 0,5
              ps(i,j,k)=0.53456+(i+j+k)/10.
              aj(i,j,k)=0.53456+(i+j+k)/10.
              vs(i,j,k)=0.53456+(i+j+k)/10.
              ws(i,j,k)=0.53456+(i+j+k)/10.
              cj(i,j,k)=0.53456+(i+j+k)/10.
              pp(i,j,k)=0.53456+(i+j+k)/10.
              bj(i,j,k)=0.53456+(i+j+k)/10.
              bb(i,j,k)=0.53456+(i+j+k)/10.
              t(i,j,k)=0.53456+(i+j+k)/10.
              u(i,j,k)=0.53456+(i+j+k)/10.
              v(i,j,k)=0.53456+(i+j+k)/10.
              w(i,j,k)=0.53456+(i+j+k)/10.
              ds(i,j,k)=0.53456+(i+j+k)/10.
              vc(i,j,k)=0.53456+(i+j+k)/10.
              ds1(i,j,k)=0.53456+(i+j+k)/10.
              us(i,j,k)=0.53456+(i+j+k)/10.
            ENDDO
          ENDDO
          xd(i)=0.53456+i/10.
          yd(i)=0.53456+i/10.
          zd(i)=0.53456+i/10.
          xx(i)=0.53456+i/10.
          yy(i)=0.53456+i/10.
          zz(i)=0.53456+i/10.
          xi(i)=0.53456+i/10.
          yj(i)=0.53456+i/10.
          zk(i)=0.53456+i/10.
        ENDDO
C	/* initialize the data */
        DO i = 0,5
          DO j = 0,5
            DO k = 0,5
              mm(i,j,k)=1
            ENDDO
          ENDDO
          dy(i)=1.0
          dz(i)=1.0
          dx(i)=1.0
          dxh(i)=1.0
          dyh(i)=1.0
          dzh(i)=1.0
        ENDDO
C	/* Search for new calculation domain  */
        DO i = nx,nmx
          jm=nmy
          nn=0
          DO j = ny,nmy
            im=nmz
            km=0
            DO k = nz,nmz
              IF (mm(i,j,k).eq.1.or.mm(i,j,k).eq.3) THEN
                IF (k.lt.im)   im=k
                IF (k.gt.km)   km=k
                IF (j.lt.jm)   jm=j
                IF (j.gt.nn)   nn=j
              ENDIF
  20          CONTINUE 
            ENDDO
C      		minz(i,j) = im 
            minz(i,j)=nz
Cminz(i,j) = 1                                                  
C		maxz(i,j) = km  
            maxz(i,j)=nmz
Cmaxz(i,j) = 10
  30        CONTINUE 
          ENDDO
C      	    miny(i) = jm 
Cminy(i) = 1                                                 
          miny(i)=ny
C	    maxy(i) = nn 
Cmaxy(i) = 10
          maxy(i)=nmy
  40      CONTINUE 
        ENDDO
        DO i = nx,nmx
          DO j = miny(i),maxy(i)
            DO k = minz(i,j),maxz(i,j)
              IF (mm(i,j,k).eq.1) THEN
                ds(i,j,k)=density*(1-(t(i,j,k)-tmed)/10000)
                visc=visca+t(i,j,k)*(viscb+t(i,j,k)*(viscc+viscd*t(i,j,k
     1)))
                IF (t(i,j,k).le.1147.and.viscd.ne.0.)   visc=0.01147
                q1=(u(i,j,k)*2*dy(j)*dz(k))/(dy(j)+dz(k))
                q2=(v(i,j,k)*2*dz(k)*dx(i))/(dz(k)+dx(i))
                q3=(w(i,j,k)*2*dx(i)*dy(j))/(dx(i)+dy(j))
                IF (q1.ge.q2.and.q1.ge.q3) THEN
                  q4=q1
                ELSE 
                  IF (q2.gt.q1.and.q2.ge.q3) THEN
                    q4=q2
                  ELSE 
                    q4=q3
                  ENDIF
                ENDIF
C	/ visc  /* Calculate Re number */
                q5=ds(i,j,k)*q4
                IF (q5.lt.2000) THEN
                  q6=0
                ELSE 
                  IF (q5.lt.3000) THEN
                    q6=0.0001*q5-0.2
                  ELSE 
                    q6=0.1
                  ENDIF
                ENDIF
                visct=0.01*q6*ds(i,j,k)*q4
C	/* + visc_t */  
                vc(i,j,k)=visc
                IF (mm(i+1,j,k).ne.1) THEN
                  ds(i+1,j,k)=ds(i,j,k)
                  vc(i+1,j,k)=vc(i,j,k)
                ENDIF
                IF (mm(i,j+1,k).ne.1) THEN
                  ds(i,j+1,k)=ds(i,j,k)
                  vc(i,j+1,k)=vc(i,j,k)
                ENDIF
                IF (mm(i,j,k+1).ne.1) THEN
                  ds(i,j,k+1)=ds(i,j,k)
                  vc(i,j,k+1)=vc(i,j,k)
                ENDIF
                IF (mm(i-1,j,k).ne.1) THEN
                  ds(i-1,j,k)=ds(i,j,k)
                  vc(i-1,j,k)=vc(i,j,k)
                ENDIF
                IF (mm(i,j-1,k).ne.1) THEN
                  ds(i,j-1,k)=ds(i,j,k)
                  vc(i,j-1,k)=vc(i,j,k)
                ENDIF
                IF (mm(i,j,k-1).ne.1) THEN
                  ds(i,j,k-1)=ds(i,j,k)
                  vc(i,j,k-1)=vc(i,j,k)
                ENDIF
              ENDIF
  60          CONTINUE 
            ENDDO
  70        CONTINUE 
          ENDDO
  80      CONTINUE 
        ENDDO
C        DO i = 1,10
C          do j= 1,10
C              write(6,102) i,j, (vs(i,j,k), k=1,10)
C          enddo
C        enddo
        rr1=10e+30
        wp=zp
        nn=1
        IF (nt.le.6)   wp=1.6
C	   /* Iterations */ 
 500    ku=0
        kv=0
        kw=0
        kp=0
        aq=0.
C Yijun 21.05.99
Cll = 1
C	/* compute U*,V*,W* (here is us,vs,ws)  */
C Yijun 21.05.99
Cdo 120 l=1,ll
        OPEN(unit=11,file='test.isg.0')
        is_idx1=0
        DO i = nx,nmx
          WRITE(11,*) is_idx1+1," R ","miny",1,i
          WRITE(11,*) is_idx1+1," R ","maxy",1,i
          DO j = miny(i),maxy(i)
            WRITE(11,*) is_idx1+1," R ","minz",2,i,j
            WRITE(11,*) is_idx1+1," R ","maxz",2,i,j
            DO k = minz(i,j),maxz(i,j)
              is_idx1=is_idx1+1
              WRITE(11,*) is_idx1,i,j,k
              WRITE(11,*) is_idx1," R ","mm",3,i,j,k
              WRITE(11,*) is_idx1," R ","mm",3,i,j,k
              IF (mm(i,j,k).eq.1.or.mm(i,j,k).eq.3) THEN
                kd=0
                WRITE(11,*) is_idx1," R ","vc",3,i,j,k
                visc=vc(i,j,k)
C		 call f3dBoundary() 
C 	/*compute U  */
                WRITE(11,*) is_idx1," R ","dx",1,i
                WRITE(11,*) is_idx1," R ","ds",3,i,j,k
                WRITE(11,*) is_idx1," R ","dx",1,i+1
                WRITE(11,*) is_idx1," R ","ds",3,i+1,j,k
                WRITE(11,*) is_idx1," R ","dxh",1,i
                dss=(0.5*(dx(i)*ds(i,j,k)+dx(i+1)*ds(i+1,j,k)))/dxh(i)
                WRITE(11,*) is_idx1," R ","dx",1,i
                WRITE(11,*) is_idx1," R ","ds1",3,i,j,k
                WRITE(11,*) is_idx1," R ","dx",1,i+1
                WRITE(11,*) is_idx1," R ","ds1",3,i+1,j,k
                WRITE(11,*) is_idx1," R ","dxh",1,i
                ds0=(0.5*(dx(i)*ds1(i,j,k)+dx(i+1)*ds1(i+1,j,k)))/dxh(i)
                WRITE(11,*) is_idx1," R ","us",3,i,j,k
                ue=us(i,j,k)
                WRITE(11,*) is_idx1," R ","vs",3,i,j,k
                WRITE(11,*) is_idx1," R ","vs",3,i,j-1,k
                WRITE(11,*) is_idx1," R ","dx",1,i
                WRITE(11,*) is_idx1," R ","vs",3,i+1,j,k
                WRITE(11,*) is_idx1," R ","vs",3,i+1,j-1,k
                WRITE(11,*) is_idx1," R ","dx",1,i+1
                WRITE(11,*) is_idx1," R ","dxh",1,i
                vn=(0.25*((vs(i,j,k)+vs(i,j-1,k))*dx(i)+(vs(i+1,j,k)+vs(
     1i+1,j-1,k))*dx(i+1)))/dxh(i)
                WRITE(11,*) is_idx1," R ","ws",3,i,j,k
                WRITE(11,*) is_idx1," R ","ws",3,i,j,k-1
                WRITE(11,*) is_idx1," R ","dx",1,i
                WRITE(11,*) is_idx1," R ","ws",3,i+1,j,k
                WRITE(11,*) is_idx1," R ","ws",3,i+1,j,k-1
                WRITE(11,*) is_idx1," R ","dx",1,i+1
                WRITE(11,*) is_idx1," R ","dxh",1,i
                wt=(0.25*((ws(i,j,k)+ws(i,j,k-1))*dx(i)+(ws(i+1,j,k)+ws(
     1i+1,j,k-1))*dx(i+1)))/dxh(i)
                IF (ue.ge.0) THEN
                  WRITE(11,*) is_idx1," R ","dx",1,i
                  uw=2*dx(i)
                ELSE 
                  WRITE(11,*) is_idx1," R ","dx",1,i+1
                  uw=2*dx(i+1)
                ENDIF
                IF (vn.ge.0) THEN
                  WRITE(11,*) is_idx1," R ","dy",1,j
                  WRITE(11,*) is_idx1," R ","dy",1,j-1
                  vss=dy(j)+dy(j-1)
                ELSE 
                  WRITE(11,*) is_idx1," R ","dy",1,j
                  WRITE(11,*) is_idx1," R ","dy",1,j+1
                  vss=dy(j)+dy(j+1)
                ENDIF
                IF (wt.ge.0) THEN
                  WRITE(11,*) is_idx1," R ","dz",1,k
                  WRITE(11,*) is_idx1," R ","dz",1,k-1
                  wb=dz(k)+dz(k-1)
                ELSE 
                  WRITE(11,*) is_idx1," R ","dz",1,k
                  WRITE(11,*) is_idx1," R ","dz",1,k+1
                  wb=dz(k)+dz(k+1)
                ENDIF
                WRITE(11,*) is_idx1," R ","xd",1,i
                ae=visc*xd(i)+((abs(ue)-ue)*dss)/uw
                WRITE(11,*) is_idx1," R ","xx",1,i
                aw=visc*xx(i)+((abs(ue)+ue)*dss)/uw
                WRITE(11,*) is_idx1," R ","yy",1,j
                an=visc*yy(j)+((abs(vn)-vn)*dss)/vss
                WRITE(11,*) is_idx1," R ","yj",1,j
                as=visc*yj(j)+((abs(vn)+vn)*dss)/vss
                WRITE(11,*) is_idx1," R ","zz",1,k
                at=visc*zz(k)+((abs(wt)-wt)*dss)/wb
                WRITE(11,*) is_idx1," R ","zk",1,k
                ab=visc*zk(k)+((abs(wt)+wt)*dss)/wb
                WRITE(11,*) is_idx1," R ","xd",1,i
                WRITE(11,*) is_idx1," R ","xx",1,i
                WRITE(11,*) is_idx1," R ","yj",1,j
                WRITE(11,*) is_idx1," R ","yy",1,j
                WRITE(11,*) is_idx1," R ","zk",1,k
                WRITE(11,*) is_idx1," R ","zz",1,k
                hr=visc*(xd(i)+xx(i)+yj(j)+yy(j)+zk(k)+zz(k))
                WRITE(11,*) is_idx1," W ","aj",3,i,j,k
                aj(i,j,k)=dss/dlat+hr+2*dss*(abs(ue)/uw+abs(vn)/vss+abs(
     1wt)/wb)
                WRITE(11,*) is_idx1," R ","u",3,i,j,k
                b0=(u(i,j,k)*ds0)/dlat
                WRITE(11,*) is_idx1," R ","mm",3,i+1,j,k
                WRITE(11,*) is_idx1," R ","mm",3,i+1,j,k
                WRITE(11,*) is_idx1," R ","mm",3,i,j,k
                IF (mm(i+1,j,k).eq.1.or.mm(i+1,j,k).eq.3.and.mm(i,j,k)
     1.eq.1) THEN
                  WRITE(11,*) is_idx1," R ","us",3,i-1,j,k
                  WRITE(11,*) is_idx1," R ","us",3,i,j-1,k
                  WRITE(11,*) is_idx1," R ","us",3,i+1,j,k
                  WRITE(11,*) is_idx1," R ","us",3,i,j+1,k
                  WRITE(11,*) is_idx1," R ","us",3,i,j,k+1
                  WRITE(11,*) is_idx1," R ","us",3,i,j,k-1
                  WRITE(11,*) is_idx1," R ","ps",3,i,j,k
                  WRITE(11,*) is_idx1," R ","ps",3,i+1,j,k
                  WRITE(11,*) is_idx1," R ","dxh",1,i
                  WRITE(11,*) is_idx1," R ","aj",3,i,j,k
                  WRITE(11,*) is_idx1," R ","us",3,i,j,k
                  WRITE(11,*) is_idx1," W ","us",3,i,j,k
                  us(i,j,k)=z1*(b0+aw*us(i-1,j,k)+as*us(i,j-1,k)+ae*us(i
     1+1,j,k)+an*us(i,j+1,k)+at*us(i,j,k+1)+ab*us(i,j,k-1)+(
     1ps(i,j,k)-ps(i+1,j,k))/dxh(i))/(aj(i,j,k)+visc*kd+s1)+
     1((-z1)+1)*us(i,j,k)
                ENDIF
C	 /* compute V*  */
                WRITE(11,*) is_idx1," R ","dy",1,j
                WRITE(11,*) is_idx1," R ","ds",3,i,j,k
                WRITE(11,*) is_idx1," R ","dy",1,j+1
                WRITE(11,*) is_idx1," R ","ds",3,i,j+1,k
                WRITE(11,*) is_idx1," R ","dyh",1,j
                dss=(0.5*(dy(j)*ds(i,j,k)+dy(j+1)*ds(i,j+1,k)))/dyh(j)
                WRITE(11,*) is_idx1," R ","dy",1,j
                WRITE(11,*) is_idx1," R ","ds1",3,i,j,k
                WRITE(11,*) is_idx1," R ","dy",1,j+1
                WRITE(11,*) is_idx1," R ","ds1",3,i,j+1,k
                WRITE(11,*) is_idx1," R ","dyh",1,j
                ds0=(0.5*(dy(j)*ds1(i,j,k)+dy(j+1)*ds1(i,j+1,k)))/dyh(j)
                WRITE(11,*) is_idx1," R ","us",3,i,j,k
                WRITE(11,*) is_idx1," R ","us",3,i-1,j,k
                WRITE(11,*) is_idx1," R ","dy",1,j
                WRITE(11,*) is_idx1," R ","us",3,i,j+1,k
                WRITE(11,*) is_idx1," R ","us",3,i-1,j+1,k
                WRITE(11,*) is_idx1," R ","dy",1,j+1
                WRITE(11,*) is_idx1," R ","dyh",1,j
                ue=(0.25*((us(i,j,k)+us(i-1,j,k))*dy(j)+(us(i,j+1,k)+us(
     1i-1,j+1,k))*dy(j+1)))/dyh(j)
                WRITE(11,*) is_idx1," R ","vs",3,i,j,k
                vn=vs(i,j,k)
                WRITE(11,*) is_idx1," R ","ws",3,i,j,k
                WRITE(11,*) is_idx1," R ","ws",3,i,j,k-1
                WRITE(11,*) is_idx1," R ","dy",1,j
                WRITE(11,*) is_idx1," R ","ws",3,i,j+1,k
                WRITE(11,*) is_idx1," R ","ws",3,i,j+1,k-1
                WRITE(11,*) is_idx1," R ","dy",1,j+1
                WRITE(11,*) is_idx1," R ","dyh",1,j
                wt=(0.25*((ws(i,j,k)+ws(i,j,k-1))*dy(j)+(ws(i,j+1,k)+ws(
     1i,j+1,k-1))*dy(j+1)))/dyh(j)
                IF (ue.ge.0) THEN
                  WRITE(11,*) is_idx1," R ","dx",1,i
                  WRITE(11,*) is_idx1," R ","dx",1,i-1
                  uw=dx(i)+dx(i-1)
                ELSE 
                  WRITE(11,*) is_idx1," R ","dx",1,i
                  WRITE(11,*) is_idx1," R ","dx",1,i+1
                  uw=dx(i)+dx(i+1)
                ENDIF
                IF (vn.ge.0) THEN
                  WRITE(11,*) is_idx1," R ","dy",1,j
                  vss=2*dy(j)
                ELSE 
                  WRITE(11,*) is_idx1," R ","dy",1,j+1
                  vss=2*dy(j+1)
                ENDIF
                IF (wt.ge.0) THEN
                  WRITE(11,*) is_idx1," R ","dz",1,k
                  WRITE(11,*) is_idx1," R ","dz",1,k-1
                  wb=dz(k)+dz(k-1)
                ELSE 
                  WRITE(11,*) is_idx1," R ","dz",1,k
                  WRITE(11,*) is_idx1," R ","dz",1,k+1
                  wb=dz(k)+dz(k+1)
                ENDIF
                WRITE(11,*) is_idx1," R ","xx",1,i
                ae=visc*xx(i)+((abs(ue)-ue)*dss)/uw
                WRITE(11,*) is_idx1," R ","xi",1,i
                aw=visc*xi(i)+((abs(ue)+ue)*dss)/uw
                WRITE(11,*) is_idx1," R ","yd",1,j
                an=visc*yd(j)+((abs(vn)-vn)*dss)/vss
                WRITE(11,*) is_idx1," R ","yy",1,j
                as=visc*yy(j)+((abs(vn)+vn)*dss)/vss
                WRITE(11,*) is_idx1," R ","zz",1,k
                at=visc*zz(k)+((abs(wt)-wt)*dss)/wb
                WRITE(11,*) is_idx1," R ","zk",1,k
                ab=visc*zk(k)+((abs(wt)+wt)*dss)/wb
                WRITE(11,*) is_idx1," R ","xi",1,i
                WRITE(11,*) is_idx1," R ","xx",1,i
                WRITE(11,*) is_idx1," R ","yd",1,j
                WRITE(11,*) is_idx1," R ","yy",1,j
                WRITE(11,*) is_idx1," R ","zk",1,k
                WRITE(11,*) is_idx1," R ","zz",1,k
                hr=visc*(xi(i)+xx(i)+yd(j)+yy(j)+zk(k)+zz(k))
                WRITE(11,*) is_idx1," W ","bj",3,i,j,k
                bj(i,j,k)=dss/dlat+hr+2*dss*(abs(ue)/uw+abs(vn)/vss+abs(
     1wt)/wb)
                WRITE(11,*) is_idx1," R ","v",3,i,j,k
                b0=(v(i,j,k)*ds0)/dlat
                WRITE(11,*) is_idx1," R ","mm",3,i,j+1,k
                WRITE(11,*) is_idx1," R ","mm",3,i,j+1,k
                WRITE(11,*) is_idx1," R ","mm",3,i,j,k
                IF (mm(i,j+1,k).eq.1.or.mm(i,j+1,k).eq.3.and.mm(i,j,k)
     1.eq.1) THEN
                  WRITE(11,*) is_idx1," R ","vs",3,i-1,j,k
                  WRITE(11,*) is_idx1," R ","vs",3,i,j-1,k
                  WRITE(11,*) is_idx1," R ","vs",3,i+1,j,k
                  WRITE(11,*) is_idx1," R ","vs",3,i,j+1,k
                  WRITE(11,*) is_idx1," R ","vs",3,i,j,k+1
                  WRITE(11,*) is_idx1," R ","vs",3,i,j,k-1
                  WRITE(11,*) is_idx1," R ","ps",3,i,j,k
                  WRITE(11,*) is_idx1," R ","ps",3,i,j+1,k
                  WRITE(11,*) is_idx1," R ","dyh",1,j
                  WRITE(11,*) is_idx1," R ","bj",3,i,j,k
                  WRITE(11,*) is_idx1," R ","vs",3,i,j,k
                  WRITE(11,*) is_idx1," W ","vs",3,i,j,k
                  vs(i,j,k)=z1*(b0+aw*vs(i-1,j,k)+as*vs(i,j-1,k)+ae*vs(i
     1+1,j,k)+an*vs(i,j+1,k)+at*vs(i,j,k+1)+ab*vs(i,j,k-1)+(
     1ps(i,j,k)-ps(i,j+1,k))/dyh(j))/(bj(i,j,k)+visc*kd+s1)+
     1((-z1)+1)*vs(i,j,k)
                ENDIF
C	/* compute W*  */
                WRITE(11,*) is_idx1," R ","dz",1,k
                WRITE(11,*) is_idx1," R ","ds",3,i,j,k
                WRITE(11,*) is_idx1," R ","dz",1,k+1
                WRITE(11,*) is_idx1," R ","ds",3,i,j,k+1
                WRITE(11,*) is_idx1," R ","dzh",1,k
                dss=(0.5*(dz(k)*ds(i,j,k)+dz(k+1)*ds(i,j,k+1)))/dzh(k)
                WRITE(11,*) is_idx1," R ","dz",1,k
                WRITE(11,*) is_idx1," R ","ds1",3,i,j,k
                WRITE(11,*) is_idx1," R ","dz",1,k+1
                WRITE(11,*) is_idx1," R ","ds1",3,i,j,k+1
                WRITE(11,*) is_idx1," R ","dzh",1,k
                ds0=(0.5*(dz(k)*ds1(i,j,k)+dz(k+1)*ds1(i,j,k+1)))/dzh(k)
                WRITE(11,*) is_idx1," R ","us",3,i,j,k
                WRITE(11,*) is_idx1," R ","us",3,i-1,j,k
                WRITE(11,*) is_idx1," R ","dz",1,k
                WRITE(11,*) is_idx1," R ","us",3,i,j,k+1
                WRITE(11,*) is_idx1," R ","us",3,i-1,j,k+1
                WRITE(11,*) is_idx1," R ","dz",1,k+1
                WRITE(11,*) is_idx1," R ","dzh",1,k
                ue=(0.25*((us(i,j,k)+us(i-1,j,k))*dz(k)+(us(i,j,k+1)+us(
     1i-1,j,k+1))*dz(k+1)))/dzh(k)
                WRITE(11,*) is_idx1," R ","vs",3,i,j,k
                WRITE(11,*) is_idx1," R ","vs",3,i,j-1,k
                WRITE(11,*) is_idx1," R ","dz",1,k
                WRITE(11,*) is_idx1," R ","vs",3,i,j,k+1
                WRITE(11,*) is_idx1," R ","vs",3,i,j-1,k+1
                WRITE(11,*) is_idx1," R ","dz",1,k+1
                WRITE(11,*) is_idx1," R ","dzh",1,k
                vn=(0.25*((vs(i,j,k)+vs(i,j-1,k))*dz(k)+(vs(i,j,k+1)+vs(
     1i,j-1,k+1))*dz(k+1)))/dzh(k)
                WRITE(11,*) is_idx1," R ","ws",3,i,j,k
                wt=ws(i,j,k)
                IF (ue.ge.0) THEN
                  WRITE(11,*) is_idx1," R ","dx",1,i
                  WRITE(11,*) is_idx1," R ","dx",1,i-1
                  uw=dx(i)+dx(i-1)
                ELSE 
                  WRITE(11,*) is_idx1," R ","dx",1,i
                  WRITE(11,*) is_idx1," R ","dx",1,i+1
                  uw=dx(i)+dx(i+1)
                ENDIF
                IF (vn.ge.0) THEN
                  WRITE(11,*) is_idx1," R ","dy",1,j
                  WRITE(11,*) is_idx1," R ","dy",1,j-1
                  vss=dy(j)+dy(j-1)
                ELSE 
                  WRITE(11,*) is_idx1," R ","dy",1,j
                  WRITE(11,*) is_idx1," R ","dy",1,j+1
                  vss=dy(j)+dy(j+1)
                ENDIF
                IF (wt.ge.0) THEN
                  WRITE(11,*) is_idx1," R ","dz",1,k
                  wb=2*dz(k)
                ELSE 
                  WRITE(11,*) is_idx1," R ","dz",1,k+1
                  wb=2*dz(k+1)
                ENDIF
                WRITE(11,*) is_idx1," R ","xx",1,i
                ae=visc*xx(i)+((abs(ue)-ue)*dss)/uw
                WRITE(11,*) is_idx1," R ","xi",1,i
                aw=visc*xi(i)+((abs(ue)+ue)*dss)/uw
                WRITE(11,*) is_idx1," R ","yy",1,j
                an=visc*yy(j)+((abs(vn)-vn)*dss)/vss
                WRITE(11,*) is_idx1," R ","yj",1,j
                as=visc*yj(j)+((abs(vn)+vn)*dss)/vss
                WRITE(11,*) is_idx1," R ","zd",1,k
                at=visc*zd(k)+((abs(wt)-wt)*dss)/wb
                WRITE(11,*) is_idx1," R ","zz",1,k
                ab=visc*zz(k)+((abs(wt)+wt)*dss)/wb
                WRITE(11,*) is_idx1," R ","xi",1,i
                WRITE(11,*) is_idx1," R ","xx",1,i
                WRITE(11,*) is_idx1," R ","yj",1,j
                WRITE(11,*) is_idx1," R ","yy",1,j
                WRITE(11,*) is_idx1," R ","zd",1,k
                WRITE(11,*) is_idx1," R ","zz",1,k
                hr=visc*(xi(i)+xx(i)+yj(j)+yy(j)+zd(k)+zz(k))
                WRITE(11,*) is_idx1," W ","cj",3,i,j,k
                cj(i,j,k)=dss/dlat+hr+2*dss*(abs(ue)/uw+abs(vn)/vss+abs(
     1wt)/wb)
                WRITE(11,*) is_idx1," R ","w",3,i,j,k
                b0=gz*dss+(w(i,j,k)*ds0)/dlat
                WRITE(11,*) is_idx1," R ","mm",3,i,j,k+1
                WRITE(11,*) is_idx1," R ","mm",3,i,j,k+1
                WRITE(11,*) is_idx1," R ","mm",3,i,j,k
                IF ((mm(i,j,k+1).eq.1.or.mm(i,j,k+1).eq.3.and.mm(i,j,k)
     1.eq.1).and.k.ne.nmz) THEN
                  WRITE(11,*) is_idx1," R ","ws",3,i-1,j,k
                  WRITE(11,*) is_idx1," R ","ws",3,i,j-1,k
                  WRITE(11,*) is_idx1," R ","ws",3,i+1,j,k
                  WRITE(11,*) is_idx1," R ","ws",3,i,j+1,k
                  WRITE(11,*) is_idx1," R ","ws",3,i,j,k+1
                  WRITE(11,*) is_idx1," R ","ws",3,i,j,k-1
                  WRITE(11,*) is_idx1," R ","ps",3,i,j,k
                  WRITE(11,*) is_idx1," R ","ps",3,i,j,k+1
                  WRITE(11,*) is_idx1," R ","dzh",1,k
                  WRITE(11,*) is_idx1," R ","cj",3,i,j,k
                  WRITE(11,*) is_idx1," R ","ws",3,i,j,k
                  WRITE(11,*) is_idx1," W ","ws",3,i,j,k
                  ws(i,j,k)=z1*(b0+aw*ws(i-1,j,k)+as*ws(i,j-1,k)+ae*ws(i
     1+1,j,k)+an*ws(i,j+1,k)+at*ws(i,j,k+1)+ab*ws(i,j,k-1)+(
     1ps(i,j,k)-ps(i,j,k+1))/dzh(k))/(cj(i,j,k)+visc*kd+s1)+
     1((-z1)+1)*ws(i,j,k)
                ENDIF
              ENDIF
 120          CONTINUE 
            ENDDO
          ENDDO
        ENDDO
C 	/* compute P.  */
        CLOSE(11) 
        DO i = 1,elemx
          DO j = 1,elemy
            DO k = 1,elemz
              pp(i,j,k)=0.
              IF (mm(i,j,k).eq.1) THEN
                ue=(0.5*(ds(i,j,k)*dx(i)+ds(i+1,j,k)*dx(i+1)))/dxh(i)
                uw=(ds(i,j,k)*dx(i)+ds(i-1,j,k)*dx(i-1))/(dx(i)+dx(i-1))
                vn=(0.5*(ds(i,j,k)*dy(j)+ds(i,j+1,k)*dy(j+1)))/dyh(j)
                vss=(ds(i,j,k)*dy(j)+ds(i,j-1,k)*dy(j-1))/(dy(j)+dy(j-1)
     1)
                wt=(0.5*(ds(i,j,k)*dz(k)+ds(i,j,k+1)*dz(k+1)))/dzh(k)
                wb=(ds(i,j,k)*dz(k)+ds(i,j,k-1)*dz(k-1))/(dz(k)+dz(k-1))
                bb(i,j,k)=(ds(i,j,k)-ds1(i,j,k))/dlat+(us(i,j,k)*ue-us(i
     1-1,j,k)*uw)/dx(i)+(vs(i,j,k)*vn-vs(i,j-1,k)*vss)/dy(j)+(
     1ws(i,j,k)*wt-ws(i,j,k-1)*wb)/dz(k)
              ENDIF
 140          CONTINUE 
            ENDDO
          ENDDO
        ENDDO
        DO l = 1,lp
          DO i = nx,nmx
            DO j = miny(i),maxy(i)
              DO k = minz(i,j),maxz(i,j)
                IF (mm(i,j,k).eq.1) THEN
                  ue=(0.5*(ds(i,j,k)*dx(i)+ds(i+1,j,k)*dx(i+1)))/dxh(i)
                  uw=(ds(i,j,k)*dx(i)+ds(i-1,j,k)*dx(i-1))/(dx(i)+dx(i-1
     1))
                  vn=(0.5*(ds(i,j,k)*dy(j)+ds(i,j+1,k)*dy(j+1)))/dyh(j)
                  vss=(ds(i,j,k)*dy(j)+ds(i,j-1,k)*dy(j-1))/(dy(j)+dy(j-
     11))
                  wt=(0.5*(ds(i,j,k)*dz(k)+ds(i,j,k+1)*dz(k+1)))/dzh(k)
                  wb=(ds(i,j,k)*dz(k)+ds(i,j,k-1)*dz(k-1))/(dz(k)+dz(k-1
     1))
                  IF (mm(i+1,j,k).eq.2) THEN
                    ae=0
                  ELSE 
                    ae=ue/aj(i,j,k)/(dx(i)*dxh(i))
                  ENDIF
C 	/* X-axis symmetry */
                  IF (mm(i-1,j,k).eq.2.or.i.eq.1.and.symx.eq.1) THEN
                    aw=0
                  ELSE 
                    aw=uw/aj(i-1,j,k)/(dx(i)*dxh(i-1))
                  ENDIF
                  IF (mm(i,j+1,k).eq.2) THEN
                    an=0
                  ELSE 
                    an=vn/bj(i,j,k)/(dy(j)*dyh(j))
                  ENDIF
C 	/* Y-axis symmetry  */
                  IF (mm(i,j-1,k).eq.2.or.j.eq.1.and.symy.eq.1) THEN
                    as=0
                  ELSE 
                    as=vss/bj(i,j-1,k)/(dy(j)*dyh(j-1))
                  ENDIF
                  IF (mm(i,j,k+1).eq.2) THEN
                    at=0
                  ELSE 
                    at=wt/cj(i,j,k)/(dzh(k)*dz(k))
                  ENDIF
                  IF (mm(i,j,k-1).eq.2) THEN
                    ab=0
                  ELSE 
                    ab=wb/cj(i,j,k-1)/(dz(k)*dzh(k-1))
                  ENDIF
                  hr=aw+ae+an+as+at+ab
                  pp(i,j,k)=(wp*((ae*pp(i+1,j,k)+aw*pp(i-1,j,k)+an*pp(i,
     1j+1,k)+as*pp(i,j-1,k)+at*pp(i,j,k+1)+ab*pp(i,j,k-1))-
     1bb(i,j,k)))/hr+((-wp)+1)*pp(i,j,k)
                ENDIF
 160            CONTINUE 
              ENDDO
            ENDDO
          ENDDO
        ENDDO
        DO i = nx,nmx
          DO j = miny(i),maxy(i)
            DO k = minz(i,j),maxz(i,j)
              IF (mm(i,j,k).eq.1) THEN
                ps(i,j,k)=ps(i,j,k)+pp(i,j,k)
                IF (abs(bb(i,j,k)).gt.eps)   kp=kp+1
                IF (abs(bb(i,j,k)).gt.aq) THEN
                  aq=abs(bb(i,j,k))
                ENDIF
                IF (mm(i+1,j,k).ne.2) THEN
                  hr=(pp(i,j,k)-pp(i+1,j,k))/(aj(i,j,k)*dxh(i))
                  us(i,j,k)=us(i,j,k)+hr
                ENDIF
                IF (mm(i,j+1,k).ne.2) THEN
                  hr=(pp(i,j,k)-pp(i,j+1,k))/(bj(i,j,k)*dyh(j))
                  vs(i,j,k)=vs(i,j,k)+hr
                ENDIF
                IF (mm(i,j,k+1).ne.2.and.k.ne.nmz) THEN
                  hr=(pp(i,j,k)-pp(i,j,k+1))/(cj(i,j,k)*dzh(k))
                  ws(i,j,k)=ws(i,j,k)+hr
                ENDIF
              ENDIF
 180          CONTINUE 
            ENDDO
          ENDDO
        ENDDO
        DO i = nx,nmx
          DO j = miny(i),maxy(i)
            DO k = minz(i,j),maxz(i,j)
              IF (mm(i,j,k).eq.1) THEN
                IF (mm(i-1,j,k).eq.2)   ps(i-1,j,k)=ps(i,j,k)
                IF (mm(i+1,j,k).eq.2)   ps(i+1,j,k)=ps(i,j,k)
                IF (mm(i,j-1,k).eq.2)   ps(i,j-1,k)=ps(i,j,k)
                IF (mm(i,j+1,k).eq.2)   ps(i,j+1,k)=ps(i,j,k)
                IF (mm(i,j,k-1).eq.2)   ps(i,j,k-1)=ps(i,j,k)
                IF (mm(i,j,k+1).eq.2)   ps(i,j,k+1)=ps(i,j,k)
              ENDIF
 200          CONTINUE 
            ENDDO
          ENDDO
        ENDDO
        ni=ni+1
        IF (rr1-aq.lt.0.2.and.rr1.gt.aq)   wp=wp+0.05
        IF (wp.gt.1.945)   wp=1.945
        rr1=aq
        IF (kp.eq.0.or.ni.eq.40)   nn=0
C temperorarily removed
Cif(nn .ne. 0) goto 500	
        DO i = 1,2
          DO j = 1,2
            WRITE(6,102) i,j,(ws(i,j,k),k=1,2) 
 102        FORMAT(1x,2i2,1x,10f12.7)
          ENDDO
        ENDDO
        END
