	PARAMETER(MAXDIM=11)
C	subroutine f3dFlow

	integer miny(MAXDIM),maxy(MAXDIM),minz(MAXDIM,MAXDIM),maxz(MAXDIM,MAXDIM) 
 	real 	RR1,wp,KD

	integer mm(0:MAXDIM,0:MAXDIM,0:MAXDIM)
	real  t(0:MAXDIM,0:MAXDIM,0:MAXDIM),u(0:MAXDIM,0:MAXDIM,0:MAXDIM)
   	real  v(0:MAXDIM,0:MAXDIM,0:MAXDIM),w(0:MAXDIM,0:MAXDIM,0:MAXDIM)
   	real  ds(0:MAXDIM,0:MAXDIM,0:MAXDIM),vc(0:MAXDIM,0:MAXDIM,0:MAXDIM)
   	real  ds1(0:MAXDIM,0:MAXDIM,0:MAXDIM),us(0:MAXDIM,0:MAXDIM,0:MAXDIM)
   	real  ps(0:MAXDIM,0:MAXDIM,0:MAXDIM),aj(0:MAXDIM,0:MAXDIM,0:MAXDIM)
   	real  vs(0:MAXDIM,0:MAXDIM,0:MAXDIM),ws(0:MAXDIM,0:MAXDIM,0:MAXDIM)
   	real  cj(0:MAXDIM,0:MAXDIM,0:MAXDIM),pp(0:MAXDIM,0:MAXDIM,0:MAXDIM)
   	real  bj(0:MAXDIM,0:MAXDIM,0:MAXDIM),bb(0:MAXDIM,0:MAXDIM,0:MAXDIM)
	
	real dx(0:MAXDIM),dy(0:MAXDIM),dz(0:MAXDIM)
	real xd(0:MAXDIM),yd(0:MAXDIM),zd(0:MAXDIM)
	real xx(0:MAXDIM),yy(0:MAXDIM),zz(0:MAXDIM)
	real xi(0:MAXDIM),yj(0:MAXDIM),zk(0:MAXDIM)
	real dxh(0:MAXDIM),dyh(0:MAXDIM),dzh(0:MAXDIM)

	data nx/1/,nmx/6/, ny/1/, nmy/6/,nz/1/, nmz/6/

c        call srandom(10001)

	dlat = 1.
	z1 = 0.5
	density = 100.
        DO i = 0,MAXDIM
          do J= 0,MAXDIM
            DO K=0,MAXDIM
              ps(i,j,k)= 0.53456+(i+j+k)/10.
              aj(i,j,k)= 0.53456+(i+j+k)/10.
              vs(i,j,k)=0.53456+(i+j+k)/10.
              ws(i,j,k)=0.53456+(i+j+k)/10.
              cj(i,j,k)=0.53456+(i+j+k)/10.
              pp(i,j,k)=0.53456+(i+j+k)/10.
              bj(i,j,k)=0.53456+(i+j+k)/10.
              bb(i,j,k)=0.53456+(i+j+k)/10.
              t(i,j,k)=0.53456+(i+j+k)/10.
              u(i,j,k)=0.53456+(i+j+k)/10.
              v(i,j,k)=0.53456+(i+j+k)/10.
              w(i,j,k)=0.53456+(i+j+k)/10.
              ds(i,j,k)=0.53456+(i+j+k)/10.
              vc(i,j,k)=0.53456+(i+j+k)/10.
              ds1(i,j,k)=0.53456+(i+j+k)/10.
              us(i,j,k)=0.53456+(i+j+k)/10.
            enddo
          enddo
              xd(i)=0.53456+i/10.
              yd(i)=0.53456+i/10.
              zd(i)=0.53456+i/10.
              xx(i)=0.53456+i/10.
              yy(i)=0.53456+i/10.
              zz(i)=0.53456+i/10.
              xi(i)=0.53456+i/10.
              yj(i)=0.53456+i/10.
              zk(i)=0.53456+i/10.
        enddo

	
C	/* initialize the data */
	do i = 0,MAXDIM
	  do j = 0,MAXDIM
	    do k = 0,MAXDIM
		mm(i,j,k)=1
	    enddo
	  enddo
	  dy(i) = 1.0
	  dz(i) = 1.0
	  dx(i) = 1.0
	  dxh(i) = 1.0
	  dyh(i) = 1.0
	  dzh(i) = 1.0
	enddo	    

C	/* Search for new calculation domain  */

	do 40 i=nx, nmx
   	    jm = nmy 
 	    nn = 0 
    	    do 30 j = ny ,nmy
      		im = nmz 
	 	km = 0 
         	do 20 k = nz ,nmz
      		   if(mm(i,j,k) .eq. 1 .or. mm(i,j,k) .eq. 3 ) then
         		if ( k .lt. im ) im = k 
	 		if ( k .gt. km ) km = k 
          		if ( j .lt. jm ) jm = j 
	 		if ( j .gt. nn ) nn = j 
       		   endif 
20		continue
      		minz(i,j) = im 
      		!minz(i,j) = nz
      		!minz(i,j) = 1
		maxz(i,j) = km  
		!maxz(i,j) = nmz
		!maxz(i,j) = 10
30	    continue 
      	    miny(i) = jm 
      	    !miny(i) = 1
      	    !miny(i) = ny
	    maxy(i) = nn 
	    !maxy(i) = 10
	    !maxy(i) = nmy
40	continue

	do 80 i=nx , nmx
  	 do 70 j=miny(i) , maxy(i)
   	  do 60 k=minz(i,j), maxz(i,j)
    	   if ( mm(i,j,k) .eq. 1) then
             ds(i,j,k) = density*(1-(t(i,j,k)-tmed)/10000) 
        visc = visca+t(i,j,k)*(viscb+t(i,j,k)*(viscc+viscd*t(i,j,k)))   
             if( t(i,j,k) .le. 1147 .and. viscd .ne. 0. ) visc = 0.01147 
       	     q1 = u( i,j,k ) * 2 * dy(j)*dz(k)/ (dy(j)+dz(k) ) 
       	     q2 = v( i,j,k ) * 2 * dz(k)*dx(i)/ (dz(k)+dx(i) ) 
       	     q3 = w( i,j,k ) * 2 * dx(i)*dy(j)/ (dx(i)+dy(j) ) 
       	     if( q1 .ge. q2 .and. q1 .ge. q3 ) then
		q4 = q1 
             else 
		if( q2 .gt. q1 .and. q2 .ge. q3 ) then
		  q4 = q2 
                else 
		  q4 = q3
		endif
	     endif
C	/ visc  /* Calculate Re number */
       	     q5 = ds( i,j,k ) * q4 
       	     if ( q5 .lt. 2000 ) then
		q6 = 0 
             else 
		if ( q5 .lt. 3000 ) then
		  q6 = 0.1*(0.001*q5 - 2. ) 
                else 
		  q6 = 0.1 
	        endif
	     endif
             visct = 0.01 * q6 * ds( i,j,k ) * q4 
C	/* + visc_t */  
       	     vc( i,j,k ) = visc   
       	     if( mm(i+1,j,k) .ne. 1 ) then
	 	ds( i+1,j,k ) = ds( i,j,k )
                vc( i+1,j,k ) = vc( i,j,k ) 
	     endif
             if( mm(i,j+1,k) .ne. 1 ) then 
		ds( i,j+1,k ) = ds( i,j,k )
                vc( i,j+1,k ) = vc( i,j,k ) 
	     endif
             if( mm(i,j,k+1) .ne. 1 ) then 
		ds( i,j,k+1 ) = ds( i,j,k )
                vc( i,j,k+1 ) = vc( i,j,k ) 
	     endif
             if( mm(i-1,j,k) .ne. 1 ) then 
		ds( i-1,j,k ) = ds( i,j,k )
                vc( i-1,j,k ) = vc( i,j,k ) 
	     endif
             if( mm(i,j-1,k) .ne. 1 ) then
		 ds( i,j-1,k ) = ds( i,j,k )
                 vc( i,j-1,k ) = vc( i,j,k ) 
	     endif
             if( mm(i,j,k-1) .ne. 1 ) then
		ds( i,j,k-1 ) = ds( i,j,k )
                vc( i,j,k-1 ) = vc( i,j,k ) 
	     endif
	   endif
60	continue
70	continue
80	continue


C        DO i = 1,10
C          do j= 1,10
C              write(6,102) i,j, (vs(i,j,k), k=1,10)
C          enddo
C        enddo

	RR1 = 10e+30
	wp =zp 
	nn = 1  
  	if( nt .le. 6) wp = 1.6 

C	   /* Iterations */ 
500	  ku=0 
	  kv=0 
	  kw=0 
	  kp=0  
	  aq = 0. 
	  ! Yijun 21.05.99
	  ll = 1
C	/* compute U*,V*,W* (here is us,vs,ws)  */
	  ! Yijun 21.05.99
  	  do 120 l=1,ll
   	   do 120 i=nx , nmx
    	    do 120 j=miny(i) , maxy(i)
	     !$doisv
     	     do 120 k=minz(i,j) , maxz(i,j)
      	       if(mm(i,j,k) .eq. 1 .or. mm(i,j,k) .eq. 3 ) then
        	 KD = 0 
        	 visc = vc( i,j,k )  
C		 call f3dBoundary() 
C 	/*compute U  */
		 dss=0.5*(dx(i)*ds(i,j,k)+dx(i+1)*ds( i+1,j,k))/dxh(i) 
		 ds0=0.5*(dx(i)*ds1(i,j,k)+dx(i+1)*ds1(i+1,j,k))/dxh(i) 
		 ue = us(i,j,k) 
 		 vn=0.25*((vs(i,j,k)+vs(i,j-1,k))*dx(i)+
     +			(vs(i+1,j,k)+vs(i+1,j-1,k))* dx(i+1) ) / dxh(i) 
		 wt = 0.25 * ( ( ws(i,j,k) + ws(i,j,k-1) ) * dx(i) + 
     +			( ws(i+1,j,k) + ws(i+1,j,k-1) ) * dx(i+1) ) / dxh(i) 
		 if ( ue .ge. 0 ) then
		      uw = 2*dx(i)       
		 else 
		      uw = 2*dx(i+1)     
		 endif
		 if ( vn .ge. 0 ) then 
		      vss= dy(j)+dy(j-1) 
	         else 
		      vss= dy(j)+dy(j+1) 
		 endif
		 if ( wt .ge. 0 ) then
		       wb = dz(k)+dz(k-1) 
		 else 
		       wb = dz(k)+dz(k+1) 
		 endif
		 ae = visc * xd(i) + (abs(ue) - ue ) * dss / uw 
		 aw = visc * xx(i) + (abs(ue) + ue ) * dss / uw 
		 an = visc * yy(j) + (abs(vn) - vn ) * dss /vss 
		 as = visc * yj(j) + (abs(vn) + vn ) * dss /vss 
		 at = visc * zz(k) + (abs(wt) - wt ) * dss / wb 
		 ab = visc * zk(k) + (abs(wt) + wt ) * dss / wb 
		 hr = visc * ( xd(i) + xx(i) + yj(j) +yy(j) + zk(k) + zz(k) ) 
		 aj(i,j,k) = dss / dlat + hr + 2*dss* 
     +			( abs(ue)/uw + abs(vn)/vss + abs(wt)/wb )   
		 b0 = u( i,j,k ) * ds0 / dlat 
		 if(mm(i+1,j,k).eq.1.or.
     +			(mm(i+1,j,k).eq.3.and.mm(i,j,k).eq.1)) then
		   us(i,j,k) = z1* ( (b0 + aw*us(i-1,j,k) + as*us(i,j-1,k) +
     +			ae*us(i+1,j,k) + an*us(i,j+1,k) + at*us(i,j,k+1) + 
     +			ab*us(i,j,k-1) + (ps( i,j,k )- 
     +			ps(i+1,j,k))/dxh(i)) / ( aj( i,j,k ) +
     +			 visc * KD + s1) ) + (1-z1) * us(i,j,k)  
		 endif

C	 /* compute V*  */
		 dss= 0.5*(dy(j)*ds(i,j,k)+dy(j+1)*ds( i,j+1,k))/dyh(j) 
		 ds0= 0.5*(dy(j)*ds1(i,j,k)+dy(j+1)*ds1(i,j+1,k))/dyh(j) 
 		 ue = 0.25 * ( ( us(i,j,k) + us(i-1,j,k) ) * dy(j) + 
     +			( us(i,j+1,k) + us(i-1,j+1,k) ) * dy(j+1) ) / dyh(j) 
 		 vn = vs(i,j,k)  
		 wt = 0.25 * ( ( ws(i,j,k) + ws(i,j,k-1) ) * dy(j) + 
     +			( ws(i,j+1,k) + ws(i,j+1,k-1) ) * dy(j+1) ) / dyh(j) 
		 if ( ue .ge. 0 ) then
		       uw = dx(i)+dx(i-1) 
		 else 
		       uw = dx(i)+dx(i+1)
		 endif
		 if ( vn .ge. 0 ) then
		       vss= 2*dy(j)       
		 else 
		       vss= 2*dy(j+1)     
		 endif
		 if ( wt .ge. 0 ) then 
			wb = dz(k)+dz(k-1) 
		 else 
			wb = dz(k)+dz(k+1) 
		 endif
		 ae = visc * xx(i) + (abs(ue) - ue ) * dss / uw 
		 aw = visc * xi(i) + (abs(ue) + ue ) * dss / uw 
		 an = visc * yd(j) + (abs(vn) - vn ) * dss /vss 
		 as = visc * yy(j) + (abs(vn) + vn ) * dss /vss 
		 at = visc * zz(k) + (abs(wt) - wt ) * dss / wb 
		 ab = visc * zk(k) + (abs(wt) + wt ) * dss / wb 
		 hr = visc * ( xi(i) + xx(i) + yd(j) +yy(j) + zk(k) + zz(k) ) 
		 bj( i,j,k ) = dss / dlat + hr + 
     +			2*dss*( abs(ue)/uw + abs(vn)/vss + abs(wt)/wb )   
		 b0 = v( i,j,k ) * ds0 / dlat 
		 if(mm(i,j+1,k) .eq. 1 .or. 
     +			(mm(i,j+1,k) .eq. 3 .and. mm(i,j,k) .eq. 1 ) ) then
		   vs(i,j,k) = z1* ( (b0 + aw*vs(i-1,j,k) + as*vs(i,j-1,k) + 
     +		     ae*vs(i+1,j,k) + an*vs(i,j+1,k) + at*vs(i,j,k+1) + 
     +		     ab*vs(i,j,k-1) + (ps(i,j,k)-ps(i,j+1,k))/dyh(j))
     +		     /(bj(i,j,k)+ visc * KD  +s1)) + (1-z1) * vs(i,j,k)  
		 endif

C	/* compute W*  */
		dss= 0.5*(dz(k)*ds(i,j,k)+dz(k+1)*ds(i,j,k+1))/dzh(k) 
		ds0= 0.5*(dz(k)*ds1(i,j,k)+dz(k+1)*ds1(i,j,k+1))/dzh(k) 
 		 ue = 0.25 * ( ( us(i,j,k) + us(i-1,j,k) ) * dz(k) + 
     +			( us(i,j,k+1) + us(i-1,j,k+1) ) * dz(k+1) ) / dzh(k) 
 		 vn = 0.25 * ( ( vs(i,j,k) + vs(i,j-1,k) ) * dz(k) + 
     +			( vs(i,j,k+1) + vs(i,j-1,k+1) ) * dz(k+1) ) / dzh(k) 
		 wt = ws(i,j,k) 
		 if ( ue .ge. 0 ) then
			uw = dx(i)+dx(i-1) 
		 else 
			uw = dx(i)+dx(i+1) 
		 endif
		 if ( vn .ge. 0 ) then 
			vss= dy(j)+dy(j-1) 
		 else 
			vss= dy(j)+dy(j+1)
		 endif
		 if ( wt .ge. 0 ) then 
			wb = 2*dz(k)       
		 else 
			wb = 2*dz(k+1)     
		 endif
		 ae = visc * xx(i) + (abs(ue) - ue ) * dss / uw 
		 aw = visc * xi(i) + (abs(ue) + ue ) * dss / uw 
		 an = visc * yy(j) + (abs(vn) - vn ) * dss /vss 
		 as = visc * yj(j) + (abs(vn) + vn ) * dss /vss 
		 at = visc * zd(k) + (abs(wt) - wt ) * dss / wb 
		 ab = visc * zz(k) + (abs(wt) + wt ) * dss / wb 
		 hr = visc * ( xi(i) + xx(i) + yj(j) +yy(j) + zd(k) + zz(k) ) 
		 cj( i,j,k ) = dss / dlat + hr + 
     +			2*dss*( abs(ue)/uw + abs(vn)/vss + abs(wt)/wb )   
		 b0 =  Gz*dss + w( i,j,k ) * ds0 / dlat 
		 if( (mm(i,j,k+1) .eq. 1 .or. (mm(i,j,k+1).eq.3 
     +			.and. mm(i,j,k).eq.1)) .and. k .ne. nmz) then
		   ws(i,j,k) = z1* ((b0 + aw*ws(i-1,j,k) + as*ws(i,j-1,k) +
     +		     ae*ws(i+1,j,k) + an*ws(i,j+1,k) + at*ws(i,j,k+1) + 
     +		     ab*ws(i,j,k-1) + (ps(i,j,k)-ps(i,j,k+1))/dzh(k))
     +		     /(cj(i,j,k)+ visc * KD  +s1))+(1-z1)*ws(i,j,k)  
      		 endif
	      endif
120	continue

C 	/* compute P.  */
	   do 140  i=1 , elemx
  	    do 140 j=1 , elemy
   	     do 140 k=1 , elemz
   	       pp( i,j,k ) = 0.   
     	       if (mm(i,j,k) .eq. 1 ) then
        	 ue = 0.5 * ( ds( i,j,k )*dx(i) + 
     +			ds( i+1,j,k )*dx(i+1) )/ dxh(i)   
        	 uw = (ds(i,j,k)*dx(i)+ds(i-1,j,k)
     +			*dx(i-1))/(dx(i)+dx(i-1)) 
        	 vn = 0.5 * ( ds( i,j,k )*dy(j) + 
     +			ds( i,j+1,k )*dy(j+1) )/ dyh(j)   
        	 vss= ( ds( i,j,k )*dy(j) + ds( i,j-1,k )*dy(j-1) )/
     +			(dy(j)+dy(j-1)) 
        	 wt = 0.5 * ( ds( i,j,k )*dz(k) + 
     +			ds( i,j,k+1 )*dz(k+1) )/ dzh(k)   
        	 wb = (ds(i,j,k)*dz(k)+ds(i,j,k-1)*
     +			dz(k-1))/(dz(k)+dz(k-1)) 
		 bb( i,j,k) = (ds( i,j,k ) - ds1( i,j,k))/dlat 
     +			+ ( us(i,j,k)*ue - us(i-1,j,k)*uw ) / dx(i)  + 
     +			( vs(i,j,k)*vn - vs(i,j-1,k)*vss) / dy(j) + 
     +			( ws(i,j,k)*wt - ws(i,j,k-1)*wb ) / dz(k)  
	      endif
140	 continue  
 	  do 160  l=1 ,lp
  	   do 160 i=nx , nmx
   	    do 160 j=miny(i) , maxy(i)
    	     do 160 k=minz(i,j) , maxz(i,j)
     	      if(mm(i,j,k) .eq. 1) then
       		ue = 0.5*(ds(i,j,k)*dx(i)+ds(i+1,j,k)*dx(i+1))/dxh(i)   
        	uw = ( ds( i,j,k )*dx(i) + 
     +			ds( i-1,j,k )*dx(i-1) )/(dx(i)+dx(i-1)) 
        	vn = 0.5 * ( ds( i,j,k )*dy(j) + 
     +			ds( i,j+1,k )*dy(j+1) )/ dyh(j)   
        	vss= (ds( i,j,k )*dy(j) + ds( i,j-1,k )*dy(j-1) )
     +			/(dy(j)+dy(j-1)) 
        	wt = 0.5 *(ds(i,j,k)*dz(k)+ds(i,j,k+1)*dz(k+1))/dzh(k)   
        	wb = (ds(i,j,k)*dz(k)+ds(i,j,k-1)*dz(k-1))/
     +			(dz(k)+dz(k-1)) 	
		if(mm(i+1,j,k) .eq. 2 ) then
			ae=0  
		else 
			ae = ue / aj( i,j,k ) /(dx(i)* dxh(i)) 
		endif
C 	/* X-axis symmetry */
		if(mm(i-1,j,k).eq.2 .or. (i.eq.1 .and. symx.eq.1)) then
		      aw=0  
		else 
		      aw = uw / aj( i-1,j,k ) /(dx(i)* dxh(i-1))  
		endif
		if(mm(i,j+1,k) .eq. 2 ) then 
		      an=0  
		else 
		      an = vn / bj( i,j,k ) /(dy(j)* dyh(j))  
		endif
C 	/* Y-axis symmetry  */
		if(mm(i,j-1,k).eq.2 .or. (j.eq.1 .and. symy.eq.1)) then 
		      as=0  
		else 
		      as = vss / bj( i,j-1,k ) /(dy(j)* dyh(j-1)) 
		endif
		if(mm(i,j,k+1) .eq. 2 ) then
		      at=0  
		else 
		      at = wt / cj( i,j,k ) / (dzh(k)*dz(k)) 
		endif
		if(mm(i,j,k-1) .eq. 2 ) then
		     ab=0  
		else 
		      ab = wb / cj( i,j,k-1 ) /(dz(k)* dzh(k-1))  
		endif
		hr = aw + ae + an + as + at + ab 
		pp(i,j,k) = wp*(ae*pp(i+1,j,k)+aw*pp(i-1,j,k) +
     +			an*pp(i,j+1,k) + as*pp(i,j-1,k) + 
     +			at*pp(i,j,k+1) + ab*pp(i,j,k-1) - 
     +			bb(i,j,k)) / hr +(1-wp)* pp(i,j,k)   
     	      endif
160 	continue

 	  do 180 i=nx , nmx
  	   do 180 j=miny(i) , maxy(i)
   	    do 180 k=minz(i,j) , maxz(i,j)
    	     if(mm(i,j,k) .eq. 1) then
      	       ps( i,j,k ) = ps(i,j,k)+pp( i,j,k ) 
      	       if ( abs (bb( i,j,k ) ) .gt. eps ) kp = kp + 1 
      	       if ( abs(bb( i,j,k)) .gt. aq ) then
		     aq = abs (bb( i,j,k ) ) 
	       endif
      	       if( mm(i+1,j,k) .ne. 2) then
		 hr = (pp(i,j,k)-pp(i+1,j,k))/(aj(i,j,k)*dxh(i)) 
 		 us(i,j,k) = us(i,j,k) + hr 
	       endif
      	       if( mm(i,j+1,k) .ne. 2) then
		 hr = (pp(i,j,k)-pp(i,j+1,k))/(bj(i,j,k)*dyh(j)) 
		 vs(i,j,k) = vs(i,j,k) + hr  
       	       endif
      	       if( mm(i,j,k+1) .ne. 2 .and. k .ne. nmz) then
		 hr = (pp(i,j,k)-pp(i,j,k+1))/(cj(i,j,k)*dzh(k)) 
		 ws(i,j,k) = ws(i,j,k) + hr 
	       endif
      	     endif
180	 continue

 	  do 200 i=nx , nmx
  	    do 200 j=miny(i) , maxy(i)
   	      do 200 k=minz(i,j) , maxz(i,j)
    	        if(mm(i,j,k) .eq. 1 ) then
    		  if(mm(i-1,j,k) .eq. 2)   ps(i-1,j,k) = ps(i,j,k) 
      		  if(mm(i+1,j,k) .eq. 2)   ps(i+1,j,k) = ps(i,j,k) 
      		  if(mm(i,j-1,k) .eq. 2)   ps(i,j-1,k) = ps(i,j,k) 
      		  if(mm(i,j+1,k) .eq. 2)   ps(i,j+1,k) = ps(i,j,k) 
      		  if(mm(i,j,k-1) .eq. 2)   ps(i,j,k-1) = ps(i,j,k) 
      	 	  if(mm(i,j,k+1) .eq. 2)   ps(i,j,k+1) = ps(i,j,k) 
    	        endif
200	continue

 	  ni=ni+1  
	  if( (RR1 - aq) .lt. 0.2 .and. RR1 .gt. aq ) wp = wp + 0.05 
  	  if( wp .gt. 1.945) wp = 1.945
  	  RR1 = aq 
 	  if ( kp .eq. 0 .or. ni .eq. 40 )  nn = 0 

	! temperorarily removed
	if(nn .ne. 0) goto 500	

        DO i = 1,6
          do j= 1,6
              write(6,102) i,j, (ws(i,j,k), k=1,6)
102           format(1x, 2i2,1x, 6f12.7)
          enddo
        enddo

	end

