	parameter(nmax=1023)
	dimension a(nmax+1,nmax), x(nmax) 
	real a, x
 	character*20 argv
	
	narg=iargc()
	if (narg .gt. 1) then
	   call getarg(1,argv)
	   read(argv,*) n
	else
	   n = 4
	endif
	do i=1, n
	   a(i,n+1) = 1.0
	   do j=1, n
	      if (i.eq.j) then
		 a(i,j) = i
	      else
		 a(i,j) = 3.0*sin(dble(i+j))
	      endif
	   enddo
	enddo

	do i = 1,n-1
	   do j = i+1,n
		f=a(j,i)/a(i,i)
		!$doisv
		do k=i+1,n+1
		a(j,k)=a(j,k)-f*a(i,k)
	        enddo
	   enddo
	enddo

	do i=n,1,-1
	   s = 0
	   do j=1+1,n
	      s= s + a(i,j)*x(j)
	   enddo
	   x(i) = (a(i,n+2)-s)/a(i,i)
	enddo
	stop
	end
